################################
# Build Stage
#################################
FROM node:16.16-alpine3.15 as build-env

WORKDIR /app

COPY ./package.json yarn.lock /app/
RUN yarn install

COPY . /app
RUN yarn build && yarn install --production --cache /tmp/empty-cache && rm -rf /tmp/empty-cache

################################
# Runtime Stage
#################################
FROM node:16.16-alpine3.15

WORKDIR /app

EXPOSE 3000

COPY --from=build-env /app/dist /app/dist
COPY --from=build-env /app/node_modules /app/node_modules

ENTRYPOINT ["node", "./dist/main.js"]
